
<script>
import Vue from "vue";
import { assign } from "lodash";

export default {
  name: "StateComponent",
  props: {
    maxState: { type: Number, default: 3 },
    components: { type: Object, default: () => ({}) },
    template: { type: String, default: "<div></div>" }
  },
  data() { return { state: 0, compiled: null, key: 1 }; },
  watch: {
    template() {
      this.key++;
      this.compiled = Vue.compile(this.template);
    }
  },
  methods: {
    next() {
      this.state = (this.state + 1) % (this.maxState + 1);
    }
  },
  render(h) {
    assign(this.$options.components, this.components);
    if (this.compiled) {
      var ret = this.compiled.render.apply(this, h);
      ret.key = this.key; /* create a new key on each render */
      return ret;
    }
    return h("div", null, "no content");
  },
  renderError(h, err) {
    return h("pre", { style: { color: "red" } }, err.stack);
  }
};
</script>
